import { SetupWorkerApi, RequestHandler } from 'msw';
import { SetupServerApi } from 'msw/node';

type SetupApi = SetupWorkerApi | SetupServerApi;
type InitializeOptions = Parameters<SetupWorkerApi['start']>[0] | Parameters<SetupServerApi['listen']>[0];
type MswParameters = {
    msw?: RequestHandler[] | {
        handlers: RequestHandler[] | Record<string, RequestHandler>;
    };
};
type Context = {
    parameters: MswParameters;
};
declare function initialize(options?: InitializeOptions): Promise<SetupApi>;
declare function getWorker(): SetupApi;
/**
 * @deprecated Use mswLoader instead, as it is much more reliable.
 * ```diff
 * - import { mswDecorator } from 'msw-storybook-addon';
 * + import { mswLoader } from 'msw-storybook-addon';
 *
 * - export const decorators = [mswDecorator];
 * + export const loaders = [mswLoader];
 * ```
 */
declare const mswDecorator: <Story extends (...args: any[]) => any>(storyFn: Story, context: Context) => any;
declare const mswLoader: (context: Context) => Promise<{}>;

export { InitializeOptions, MswParameters, SetupApi, getWorker, initialize, mswDecorator, mswLoader };
